# 1 "src/dlexer.mll"
 
open Util
open Dparser

(*
** Keyword hashtable
*)

let string_of lb = (Lexing.lexeme lb) 

let lexicon = Hashtbl.create 211
let _ = List.iter 
    (fun (key, token) -> Hashtbl.add lexicon key token)
    [ 
	    ("ADD_MAP_NOTE", ADD_MAP_NOTE); 
      ("ACTION_IF", ACTION_IF) ;
      ("ADD_CRE_ITEM", ADD_CRE_ITEM) ;
      ("ADD_GAME_NPC", PATCH_GAM) ;
      ("ADD_KIT", ADD_KIT) ;
      ("ADD_KNOWN_SPELL", ADD_KNOWN_SPELL) ;
      ("ADD_MUSIC", ADD_MUSIC) ;
      ("ADD_PROJECTILE", ADD_PROJECTILE) ;
      ("ADD_STATE_TRIGGER", ADD_STATE_TRIGGER) ;
      ("ADD_STORE_ITEM", ADD_STORE_ITEM);
      ("ADD_TRANS_ACTION", ADD_TRANS_ACTION) ;
      ("ADD_TRANS_TRIGGER", ADD_TRANS_TRIGGER) ;
      ("ALLOW_MISSING", ALLOW_MISSING) ; 
      ("ALWAYS", ALWAYS) ; 
      ("APPEND", APPEND); 
      ("APPENDI", APPENDI); 
      ("APPEND_COL", APPEND_COL); 
      ("APPEND_FILE", APPEND_FILE); 
      ("APPLY_BCS_PATCH", APPLY_BCS_PATCH) ;
      ("APPLY_BCS_PATCH_OR_COPY", APPLY_BCS_PATCH_OR_COPY) ;
      ("ASK_EVERY_COMPONENT", ASK_EVERY_COMPONENT); 
      ("AT_EXIT", AT_EXIT); 
      ("AT_INTERACTIVE_EXIT", AT_INTERACTIVE_EXIT); 
      ("AT_INTERACTIVE_UNINSTALL", AT_INTERACTIVE_UNINSTALL); 
      ("AT_UNINSTALL", AT_UNINSTALL); 
      ("AUTHOR", AUTHOR); 
      ("AUTO_TRA", AUTO_TRA); 
      ("A_B_P", APPLY_BCS_PATCH) ;
      ("A_S_T", ADD_STATE_TRIGGER) ;
      ("A_T_T", ADD_TRANS_TRIGGER) ;
      ("BACKUP", BACKUP) ;
      ("BEGIN", BEGIN) ;
      ("BUT_ONLY_IF_IT_CHANGES", BUT_ONLY_IF_IT_CHANGES); 
      ("CHAIN", CHAIN3);
      ("CHAIN2", CHAIN2);
      ("CHAIN3", CHAIN3);
      ("COMPILE", COMPILE);
      ("COMPILE_BAF_TO_BCS", COMPILE_BAF_TO_BCS);
      ("COMPILE_D_TO_DLG", COMPILE_D_TO_DLG);
      ("COPY", COPY);
      ("COPY_EXISTING", COPY_EXISTING);
      ("COPY_EXISTING_REGEXP", COPY_EXISTING_REGEXP);
      ("COPY_RANDOM", COPY_RANDOM);
      ("COPY_TRANS", COPY_TRANS);
      ("DECOMPILE_BCS_TO_BAF", DECOMPILE_BCS_TO_BAF);
      ("DECOMPILE_DLG_TO_D", DECOMPILE_DLG_TO_D);
      ("DELETE_BYTES", DELETE_BYTES);
      ("DEPRECATED", DEPRECATED); 
      ("DESCRIBE_ITEM", DESCRIBE_ITEM) ; 
      ("DESIGNATED", DESIGNATED); 
      ("DO", DO) ;
      ("ELSE", ELSE) ;
      ("END", END) ;
      ("EQUIP", EQUIP);
      ("EXIT", EXIT) ;
      ("EXTEND",EXTEND_BOTTOM) ; 
      ("EXTEND_BOTTOM", EXTEND_BOTTOM) ; 
      ("EXTEND_BOTTOM_REGEXP", EXTEND_BOTTOM_REGEXP);
      ("EXTEND_TOP", EXTEND_TOP) ;
      ("EXTEND_TOP_REGEXP", EXTEND_TOP_REGEXP);
      ("EXTERN", EXTERN) ;
      ("FAIL", FAIL);
      ("FLAGS", FLAGS);
      ("FOR", FOR) ; 
      ("FORBID_COMPONENT", FORBID_COMPONENT) ;
      ("FORBID_FILE", FORBID_FILE) ; 
      ("GLOB", GLOB); 
      ("GOTO", GOTO) ;
      ("IF", IF) ;
      ("IF_EVAL", IF_EVAL) ;
      ("IF_SIZE_IS", IF_SIZE_IS) ;
      ("INNER_ACTION", INNER_ACTION) ;
      ("INNER_PATCH", INNER_PATCH) ;
      ("INNER_PATCH_FILE", INNER_PATCH_FILE) ;
      ("INSERT_BYTES", INSERT_BYTES);
      ("INSERT_FILE", INSERT_FILE);
      ("INSTALL_BY_DEFAULT", INSTALL_BY_DEFAULT) ;
      ("INTERJECT", INTERJECT);
      ("INTERJECT_COPY_TRANS", INTERJECT_COPY_TRANS);
      ("INTERJECT_COPY_TRANS2", INTERJECT_COPY_TRANS2);
      ("I_C_T", INTERJECT_COPY_TRANS);
      ("I_C_T2", INTERJECT_COPY_TRANS2);
      ("I_S_I", IF_SIZE_IS) ;
      ("JOURNAL", JOURNAL) ;
      ("LANGUAGE", LANGUAGE) ;
      ("MENU_STYLE", MENU_STYLE) ;
      ("MKDIR", MKDIR) ;
      ("NO_LOG_RECORD", NO_LOG_RECORD) ; 
      ("PATCH_GAM", PATCH_GAM) ;
      ("PATCH_IF", PATCH_IF) ;
      ("PATCH_PRINT", PATCH_PRINT);
      ("SPRINT", SPRINT);
      ("PRINT", PRINT);
      ("RANDOM", RANDOM);
      ("RANDOM_SEED", RANDOM_SEED);
      ("READ_2DA_ENTRY", READ_2DA_ENTRY) ;
      ("READ_ASCII", READ_ASCII);
      ("READ_STRREF", READ_STRREF);
      ("READ_BYTE", READ_BYTE) ;
      ("READ_SBYTE", READ_SBYTE) ;
      ("READ_LONG", READ_LONG) ;
      ("READ_SHORT", READ_SHORT) ;
      ("REMOVE_KNOWN_SPELL", REMOVE_KNOWN_SPELL) ;
      ("REPLACE", REPLACE) ;
      ("REPLACE_ACTION_TEXT", REPLACE_ACTION_TEXT) ;
      ("REPLACE_ACTION_TEXT_PROCESS", REPLACE_ACTION_TEXT_PROCESS) ;
      ("REPLACE_ACTION_TEXT_PROCESS_REGEXP", REPLACE_ACTION_TEXT_PROCESS_REGEXP) ;
      ("REPLACE_ACTION_TEXT_REGEXP", REPLACE_ACTION_TEXT_REGEXP) ;
      ("REPLACE_BCS_BLOCK", REPLACE_BCS_BLOCK) ;
      ("REPLACE_BCS_BLOCK_REGEXP", REPLACE_BCS_BLOCK_REGEXP) ;
      ("REPLACE_EVALUATE", REPLACE_EVALUATE) ;
      ("REPLACE_SAY", REPLACE_SAY) ;
      ("REPLACE_STATE_TRIGGER", REPLACE_STATE_TRIGGER) ;
      ("REPLACE_TEXTUALLY", REPLACE_TEXTUALLY) ;
      ("REPLACE_TRIGGER_TEXT", REPLACE_TRIGGER_TEXT) ;
      ("REPLACE_TRIGGER_TEXT_REGEXP", REPLACE_TRIGGER_TEXT_REGEXP) ;
      ("REPLY", REPLY) ;
      ("REQUIRE_COMPONENT", REQUIRE_COMPONENT) ;
      ("REQUIRE_FILE", REQUIRE_FILE) ;
      ("REQUIRE_PREDICATE", REQUIRE_PREDICATE) ;
      ("R_A_T", REPLACE_ACTION_TEXT) ;
      ("R_B_B", REPLACE_BCS_BLOCK) ;
      ("R_B_B_RE", REPLACE_BCS_BLOCK_REGEXP) ;
      ("R_S_T", REPLACE_STATE_TRIGGER) ;
      ("R_T_T", REPLACE_TRIGGER_TEXT) ;
      ("SAY", SAY) ;
      ("SAY_EVALUATED", SAY_EVALUATED) ;
      ("SCRIPT_STYLE", SCRIPT_STYLE) ;
      ("SET", SET); 
      ("SET_2DA_ENTRY", SET_2DA_ENTRY) ;
      ("SET_WEIGHT", SET_WEIGHT) ;
      ("SOLVED_JOURNAL", SOLVED_JOURNAL) ;
      ("STRING_COMPARE", STRING_EQUAL) ;
      ("STRING_COMPARE_CASE", STRING_EQUAL_CASE) ;
      ("STRING_SET", STRING_SET) ;
      ("STR_CMP", STRING_EQUAL) ;
      ("SUBCOMPONENT", SUBCOMPONENT) ;
      ("SUB_COMPONENT", SUBCOMPONENT) ;
      ("THEN", THEN) ;
      ("TWOHANDED", TWOHANDED); 
      ("UNINSTALL", UNINSTALL) ;
      ("UNLESS", UNLESS) ;
      ("UNSOLVED_JOURNAL", UNSOLVED_JOURNAL) ;
      ("USING", USING) ;
      ("WEIGHT", WEIGHT) ;
      ("WHILE", WHILE) ;
      ("WRITE_ASCII", WRITE_ASCII) ;
      ("WRITE_BYTE", WRITE_BYTE) ;
      ("WRITE_EVALUATED_ASCII", WRITE_EVALUATED_ASCII) ;
      ("WRITE_FILE", WRITE_FILE) ;
      ("WRITE_LONG", WRITE_LONG) ;
      ("WRITE_SHORT", WRITE_SHORT) ;

      (* predicates *) 
      ("FILE_EXISTS", FILE_EXISTS ) ;
      ("FILE_MD5", FILE_MD5 ) ;
      ("FILE_EXISTS_IN_GAME", FILE_EXISTS_IN_GAME ) ;
      ("FILE_SIZE", FILE_SIZE ) ;
      ("FILE_CONTAINS", FILE_CONTAINS ) ;
      ("FILE_CONTAINS_EVALUATED", FILE_CONTAINS_EVALUATED ) ;
      ("AND", AND) ;
      ("OR", OR) ;
      ("NOT", NOT) ;

      ("BAND", BAND) ;
      ("BOR", BOR) ;
      ("BNOT", BNOT) ;
      ("BXOR", BXOR) ;
      ("BLSL", BLSL) ;
      ("BLSR", BLSR) ;
      ("BASR", BASR) ;
    ] 

(*
** Buffer processor
*)
 




# 198 "src/dlexer.ml"
let __ocaml_lex_tables = {
  Lexing.lex_base = 
   "\000\000\224\255\223\255\253\255\252\255\251\255\250\255\249\255\
    \248\255\247\255\246\255\244\255\243\255\081\000\245\255\237\255\
    \031\000\032\000\003\000\002\000\001\000\089\000\167\000\180\000\
    \194\000\004\000\071\000\235\255\065\000\067\000\069\000\073\000\
    \076\000\087\000\007\000\005\000\001\000\225\255\022\000\023\000\
    \024\000\025\000\226\255\231\255\216\000\231\000\233\255\241\000\
    \251\000\005\001\015\001\115\000\119\000\087\000\232\255\234\255\
    \236\255\255\255\254\255\063\001\134\000\002\000\204\000\056\000\
    \057\000\059\000\087\000\065\001\164\000\165\000\176\000\178\000\
    \190\000\191\000\192\000\006\000";
  Lexing.lex_backtrk = 
   "\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\013\000\255\255\255\255\
    \015\000\014\000\032\000\032\000\032\000\025\000\032\000\032\000\
    \032\000\032\000\016\000\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\024\000\
    \255\255\255\255\255\255\255\255\255\255\028\000\255\255\255\255\
    \027\000\255\255\026\000\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\004\000\004\000\255\255\003\000\
    \255\255\255\255\255\255\255\255\003\000\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255";
  Lexing.lex_default = 
   "\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\255\255\000\000\000\000\
    \255\255\255\255\053\000\052\000\051\000\255\255\255\255\255\255\
    \255\255\038\000\255\255\000\000\255\255\255\255\255\255\255\255\
    \255\255\255\255\035\000\035\000\255\255\000\000\038\000\255\255\
    \255\255\255\255\000\000\000\000\255\255\255\255\000\000\255\255\
    \255\255\255\255\255\255\051\000\052\000\053\000\000\000\000\000\
    \000\000\000\000\000\000\005\000\255\255\255\255\004\000\255\255\
    \255\255\255\255\255\255\004\000\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\058\000";
  Lexing.lex_trans = 
   "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\004\000\005\000\037\000\003\000\003\000\000\000\037\000\
    \057\000\037\000\036\000\000\000\036\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \003\000\023\000\019\000\022\000\043\000\020\000\043\000\034\000\
    \006\000\007\000\012\000\014\000\003\000\011\000\000\000\013\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\009\000\010\000\026\000\017\000\016\000\008\000\
    \024\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\018\000\056\000\055\000\015\000\021\000\
    \054\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\057\000\021\000\029\000\025\000\030\000\
    \058\000\031\000\039\000\028\000\027\000\032\000\021\000\021\000\
    \033\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\034\000\043\000\040\000\041\000\042\000\
    \043\000\043\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\054\000\057\000\064\000\065\000\
    \021\000\066\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\049\000\057\000\003\000\050\000\
    \050\000\050\000\050\000\050\000\050\000\050\000\050\000\050\000\
    \050\000\047\000\069\000\070\000\048\000\048\000\048\000\048\000\
    \048\000\048\000\048\000\048\000\048\000\048\000\071\000\044\000\
    \072\000\046\000\045\000\045\000\045\000\045\000\045\000\045\000\
    \045\000\045\000\045\000\045\000\073\000\074\000\057\000\000\000\
    \001\000\255\255\255\255\255\255\255\255\255\255\003\000\255\255\
    \045\000\045\000\045\000\045\000\045\000\045\000\045\000\045\000\
    \045\000\045\000\000\000\000\000\000\000\000\000\255\255\045\000\
    \045\000\045\000\045\000\045\000\045\000\045\000\045\000\045\000\
    \045\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
    \048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
    \048\000\048\000\048\000\048\000\048\000\050\000\050\000\050\000\
    \050\000\050\000\050\000\050\000\050\000\050\000\050\000\050\000\
    \050\000\050\000\050\000\050\000\050\000\050\000\050\000\050\000\
    \050\000\058\000\063\000\003\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\255\255\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\060\000\000\000\000\000\000\000\000\000\061\000\000\000\
    \000\000\000\000\000\000\255\255\000\000\000\000\000\000\255\255\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\068\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\058\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\
    \000\000\058\000";
  Lexing.lex_check = 
   "\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\000\000\000\000\036\000\000\000\000\000\255\255\035\000\
    \075\000\034\000\035\000\255\255\034\000\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \000\000\000\000\000\000\000\000\019\000\000\000\020\000\034\000\
    \000\000\000\000\000\000\000\000\061\000\000\000\255\255\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\016\000\017\000\000\000\000\000\
    \018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\013\000\021\000\028\000\000\000\029\000\
    \013\000\030\000\025\000\026\000\026\000\031\000\021\000\021\000\
    \032\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\033\000\038\000\039\000\040\000\041\000\
    \051\000\052\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\053\000\060\000\063\000\064\000\
    \021\000\065\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
    \021\000\021\000\021\000\021\000\022\000\066\000\062\000\022\000\
    \022\000\022\000\022\000\022\000\022\000\022\000\022\000\022\000\
    \022\000\023\000\068\000\069\000\023\000\023\000\023\000\023\000\
    \023\000\023\000\023\000\023\000\023\000\023\000\070\000\024\000\
    \071\000\023\000\024\000\024\000\024\000\024\000\024\000\024\000\
    \024\000\024\000\024\000\024\000\072\000\073\000\074\000\255\255\
    \000\000\020\000\019\000\018\000\025\000\035\000\075\000\034\000\
    \044\000\044\000\044\000\044\000\044\000\044\000\044\000\044\000\
    \044\000\044\000\255\255\255\255\255\255\255\255\038\000\045\000\
    \045\000\045\000\045\000\045\000\045\000\045\000\045\000\045\000\
    \045\000\047\000\047\000\047\000\047\000\047\000\047\000\047\000\
    \047\000\047\000\047\000\048\000\048\000\048\000\048\000\048\000\
    \048\000\048\000\048\000\048\000\048\000\049\000\049\000\049\000\
    \049\000\049\000\049\000\049\000\049\000\049\000\049\000\050\000\
    \050\000\050\000\050\000\050\000\050\000\050\000\050\000\050\000\
    \050\000\059\000\062\000\067\000\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\053\000\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\059\000\255\255\255\255\255\255\255\255\059\000\255\255\
    \255\255\255\255\255\255\051\000\255\255\255\255\255\255\052\000\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\067\000\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\062\000\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\059\000\
    \255\255\067\000";
  Lexing.lex_base_code = 
   "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\001\000\000\000\014\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000";
  Lexing.lex_backtrk_code = 
   "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000";
  Lexing.lex_default_code = 
   "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\006\000\006\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000";
  Lexing.lex_trans_code = 
   "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \009\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000";
  Lexing.lex_check_code = 
   "\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\034\000\035\000\255\255\034\000\035\000\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \034\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\033\000\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \034\000\035\000";
  Lexing.lex_code = 
   "\255\003\255\002\255\255\003\255\255\002\255\003\255\255\001\003\
    \000\002\255";
}

let rec initial lexbuf =
  lexbuf.Lexing.lex_mem <- Array.create 4 (-1) ;   __ocaml_lex_initial_rec lexbuf 0
and __ocaml_lex_initial_rec lexbuf __ocaml_lex_state =
  match Lexing.new_engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 204 "src/dlexer.mll"
        ( adj lexbuf ; let _ = comment lexbuf in initial lexbuf)
# 494 "src/dlexer.ml"

  | 1 ->
# 205 "src/dlexer.mll"
        ( adj lexbuf ; endline lexbuf )
# 499 "src/dlexer.ml"

  | 2 ->
# 206 "src/dlexer.mll"
        ( adj lexbuf ; initial lexbuf)
# 504 "src/dlexer.ml"

  | 3 ->
# 207 "src/dlexer.mll"
        ( tab (); initial lexbuf )
# 509 "src/dlexer.ml"

  | 4 ->
# 208 "src/dlexer.mll"
        ( newline (); initial lexbuf )
# 514 "src/dlexer.ml"

  | 5 ->
# 209 "src/dlexer.mll"
        ( adj lexbuf ; LPAREN )
# 519 "src/dlexer.ml"

  | 6 ->
# 210 "src/dlexer.mll"
        ( adj lexbuf ; RPAREN )
# 524 "src/dlexer.ml"

  | 7 ->
# 211 "src/dlexer.mll"
        ( adj lexbuf ; QUESTION )
# 529 "src/dlexer.ml"

  | 8 ->
# 212 "src/dlexer.mll"
        ( adj lexbuf ; COLON )
# 534 "src/dlexer.ml"

  | 9 ->
# 213 "src/dlexer.mll"
        ( adj lexbuf ; SEMICOLON )
# 539 "src/dlexer.ml"

  | 10 ->
# 214 "src/dlexer.mll"
        ( adj lexbuf ; PLUS )
# 544 "src/dlexer.ml"

  | 11 ->
# 215 "src/dlexer.mll"
        ( adj lexbuf ; MINUS )
# 549 "src/dlexer.ml"

  | 12 ->
# 216 "src/dlexer.mll"
        ( adj lexbuf ; TIMES )
# 554 "src/dlexer.ml"

  | 13 ->
# 217 "src/dlexer.mll"
        ( adj lexbuf ; DIVIDE )
# 559 "src/dlexer.ml"

  | 14 ->
# 218 "src/dlexer.mll"
        ( adj lexbuf ; EQUALS )
# 564 "src/dlexer.ml"

  | 15 ->
# 219 "src/dlexer.mll"
        ( adj lexbuf ; GT )
# 569 "src/dlexer.ml"

  | 16 ->
# 220 "src/dlexer.mll"
        ( adj lexbuf ; LT )
# 574 "src/dlexer.ml"

  | 17 ->
# 221 "src/dlexer.mll"
        ( adj lexbuf ; PLUS )
# 579 "src/dlexer.ml"

  | 18 ->
# 222 "src/dlexer.mll"
        ( adj lexbuf ; STRING_CONCAT )
# 584 "src/dlexer.ml"

  | 19 ->
# 223 "src/dlexer.mll"
         ( adj lexbuf ; GTE )
# 589 "src/dlexer.ml"

  | 20 ->
# 224 "src/dlexer.mll"
         ( adj lexbuf ; LTE )
# 594 "src/dlexer.ml"

  | 21 ->
# 225 "src/dlexer.mll"
        ( adj lexbuf ; EQUALSEQUALS )
# 599 "src/dlexer.ml"

  | 22 ->
# 226 "src/dlexer.mll"
        ( adj lexbuf ; NOTEQUALS )
# 604 "src/dlexer.ml"

  | 23 ->
# 227 "src/dlexer.mll"
                ( str_adj lexbuf ; SOUND(strip (string_of lexbuf)) )
# 609 "src/dlexer.ml"

  | 24 ->
# 230 "src/dlexer.mll"
                 ( str_adj lexbuf ; STRING(strip (string_of lexbuf)) )
# 614 "src/dlexer.ml"

  | 25 ->
# 231 "src/dlexer.mll"
                                                                 ( 
    adj lexbuf ; try Hashtbl.find lexicon (string_of lexbuf) 
    with _ -> STRING(string_of lexbuf) )
# 621 "src/dlexer.ml"

  | 26 ->
# 234 "src/dlexer.mll"
                      ( adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      STRING_REF((int_of_string str)) )
# 629 "src/dlexer.ml"

  | 27 ->
# 238 "src/dlexer.mll"
                      ( adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      FORCED_STRING_REF((int_of_string str)) )
# 637 "src/dlexer.ml"

  | 28 ->
# 242 "src/dlexer.mll"
                      ( adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      TRANS_REF((int_of_string str)) )
# 645 "src/dlexer.ml"

  | 29 ->
# 246 "src/dlexer.mll"
          ( adj lexbuf ; let buf = Buffer.create 255 in widestring buf lexbuf )
# 650 "src/dlexer.ml"

  | 30 ->

  let name = Lexing.sub_lexeme lexbuf lexbuf.Lexing.lex_mem.(0) lexbuf.Lexing.lex_mem.(1) in
# 247 "src/dlexer.mll"
                                                       ( 
  adj lexbuf ; 
  let buf = Buffer.create 10240 in 
  inlined name buf lexbuf )
# 660 "src/dlexer.ml"

  | 31 ->
# 251 "src/dlexer.mll"
        ( EOF )
# 665 "src/dlexer.ml"

  | 32 ->
# 252 "src/dlexer.mll"
    ( lex_error (Printf.sprintf "invalid character [%s]" (string_of
lexbuf)) )
# 671 "src/dlexer.ml"

  | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_initial_rec lexbuf __ocaml_lex_state

and comment lexbuf =
    __ocaml_lex_comment_rec lexbuf 59
and __ocaml_lex_comment_rec lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 255 "src/dlexer.mll"
           ( adj lexbuf ; () )
# 682 "src/dlexer.ml"

  | 1 ->
# 256 "src/dlexer.mll"
                ( newline (); comment lexbuf )
# 687 "src/dlexer.ml"

  | 2 ->
# 257 "src/dlexer.mll"
                ( adj lexbuf ; let _ = comment lexbuf in comment lexbuf )
# 692 "src/dlexer.ml"

  | 3 ->
# 258 "src/dlexer.mll"
                ( lex_error "unterminated comment" )
# 697 "src/dlexer.ml"

  | 4 ->
# 259 "src/dlexer.mll"
         ( adj lexbuf ; comment lexbuf )
# 702 "src/dlexer.ml"

  | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_comment_rec lexbuf __ocaml_lex_state

and widestring buf lexbuf =
    __ocaml_lex_widestring_rec buf lexbuf 62
and __ocaml_lex_widestring_rec buf lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 261 "src/dlexer.mll"
                 ( adj lexbuf ; STRING(Buffer.contents buf) )
# 713 "src/dlexer.ml"

  | 1 ->
# 262 "src/dlexer.mll"
                 ( lex_error "unterminated ~~~~~ string" )
# 718 "src/dlexer.ml"

  | 2 ->
# 263 "src/dlexer.mll"
                 ( newline (); Buffer.add_char buf '\n';widestring buf lexbuf)
# 723 "src/dlexer.ml"

  | 3 ->
# 264 "src/dlexer.mll"
                 ( adj lexbuf ; let str = string_of lexbuf in
                   Buffer.add_string buf str ; widestring buf lexbuf )
# 729 "src/dlexer.ml"

  | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_widestring_rec buf lexbuf __ocaml_lex_state

and inlined name buf lexbuf =
    __ocaml_lex_inlined_rec name buf lexbuf 67
and __ocaml_lex_inlined_rec name buf lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 267 "src/dlexer.mll"
                ( adj lexbuf ; 
                  INLINED_FILE(name,(Buffer.contents buf)) )
# 741 "src/dlexer.ml"

  | 1 ->
# 269 "src/dlexer.mll"
                ( lex_error "unterminated inlined file" )
# 746 "src/dlexer.ml"

  | 2 ->
# 270 "src/dlexer.mll"
                ( newline (); Buffer.add_char buf '\n' ; 
                  inlined name buf lexbuf )
# 752 "src/dlexer.ml"

  | 3 ->
# 272 "src/dlexer.mll"
                ( adj lexbuf ; 
                  let str = string_of lexbuf in
                  Buffer.add_string buf str ;
                  inlined name buf lexbuf )
# 760 "src/dlexer.ml"

  | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_inlined_rec name buf lexbuf __ocaml_lex_state

and endline lexbuf =
    __ocaml_lex_endline_rec lexbuf 75
and __ocaml_lex_endline_rec lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 277 "src/dlexer.mll"
                ( newline (); initial lexbuf)
# 771 "src/dlexer.ml"

  | 1 ->
# 278 "src/dlexer.mll"
      ( adj lexbuf ; endline lexbuf)
# 776 "src/dlexer.ml"

  | 2 ->
# 279 "src/dlexer.mll"
                                ( EOF )
# 781 "src/dlexer.ml"

  | __ocaml_lex_state -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_endline_rec lexbuf __ocaml_lex_state

;;

